/*
 * JPA entity template
 *
 *
 * Takatuka - Template fuer JPA2 Entitaeten (inklusive Bean Validation)
 *
 * Moeglichkeiten und Einschraenkungen:
 * - Beziehungen werden abgebildet
 * -- es gibt keine 1:1 Beziehungen
 * -- N:M Beziehungen sind immer bidirektional
 * - Vererbung wird nicht unterstuetzt
 * - Support für CustomData
 */
package de.ivu.elect.business.benutzerverwaltung.entity;

@javax.persistence.NamedQueries(
 {



       @javax.persistence.NamedQuery(
     name="BENUTZER_EINSATZORT.UK",
     query="SELECT o FROM BenutzerEinsatzort o WHERE "

                         + "o"
                +".name"
              +" = ?1"

             +" AND "         + "o"
                +".mandant"
                +".nummer"
              +" = ?2"

     ,
   hints = {
              @javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
             @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
   }


   )
   
     ,   @javax.persistence.NamedQuery(
     name="BENUTZER_EINSATZORT.All",
     query="SELECT o FROM BenutzerEinsatzort o WHERE o.mandant=?1",
     hints = {@javax.persistence.QueryHint(name = "org.hibernate.cacheable", value = "true"),
                            @javax.persistence.QueryHint(name = "org.hibernate.flushMode", value = "commit")
             }
   )

        
     }
)
@javax.enterprise.inject.Vetoed
@javax.persistence.Entity
@javax.persistence.Table(name = "BENUTZER_EINSATZORT")
// @javax.persistence.IdClass(BenutzerEinsatzortPK.class)
    @javax.persistence.EntityListeners(de.ivu.elect.jee.protokollierung.ProtokollEntityListener.class)
    @javax.persistence.Cacheable

public
 class BenutzerEinsatzort
extends AbstractBenutzerEinsatzort
  {

  private static final long serialVersionUID = 0L;


  /**
   * default constructor
   */
  public BenutzerEinsatzort() {
    super();
  }

    /**
     * @param original
     *
     * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
     *             als Deprecated.
     */
    @Deprecated
    public BenutzerEinsatzort(BenutzerEinsatzort original){
      original.copyEntity(this);
    }

  /**
   * PRIMARY KEY
   */
  @javax.persistence.Id
  @javax.persistence.Column(name = "benutzer_einsatzort_id")
    @javax.persistence.GeneratedValue(strategy = javax.persistence.GenerationType.TABLE, generator = "BenutzerEinsatzort")
    @javax.persistence.TableGenerator(name = "BenutzerEinsatzort", table = "SEQUENCES", pkColumnName = "sequence_name", pkColumnValue = "BenutzerEinsatzort", valueColumnName = "next_val", allocationSize = 1000, initialValue = 0)
    protected java.lang.Long id;

  @Override
  public java.lang.Long getId() {
    return id;
  }

  public void setId(java.lang.Long id) {
    this.id = id;
  }

  @javax.persistence.Transient
  private transient BenutzerEinsatzortPK pkCache;

  @Override
  public BenutzerEinsatzortPK getPk() {
    if (pkCache==null || pkCache.getId() != id ) {
      pkCache = new BenutzerEinsatzortPK(getId());
    }

    return pkCache;
  }

  public static <E extends BenutzerEinsatzort> java.util.Map<BenutzerEinsatzortPK, E> mappeNachPk(java.util.Collection<E> entities){
    java.util.Map<BenutzerEinsatzortPK, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getPk(), entity);
    }

    return result;
  }

  public static <E extends BenutzerEinsatzort> java.util.Map<Long, E> mappeNachId(java.util.Collection<E> entities){
    java.util.Map<Long, E> result = new java.util.HashMap<>();

    for (E entity : entities) {
      result.put(entity.getId(), entity);
    }

    return result;
  }



  /**
   * Indikator, ob sich ein Attribut oder eine UNIDIREKTIONALE n:1-Beziehungen geaendert hat
   */
  @javax.persistence.Transient
  protected boolean attributeChanged = false;

  public void setAttributeChanged() {
    attributeChanged = true;
  }

  public boolean isAttributeChanged() {
    return attributeChanged;
  }

  /**
   * Hilfsvariable fuer das Aktualisieren von Beziehungen
   */
  @javax.persistence.Transient
  protected boolean updateRelationship = false;



  public void resetAttributeChanged() {
        hasChangedBemerkung = false;
          hasChangedBesonderheit = false;
          hasChangedClientIpMuster = false;
          hasChangedName = false;
  
      hasChangedMandant = false;
  
          hasChangedRolles = false;
      

    attributeChanged = false;
  }


  /**
   * ATTRIBUTE
   */

    
  @javax.persistence.Column(name = "BEMERKUNG", nullable = BenutzerEinsatzortConstants.BEMERKUNG_NULLABLE, length=BenutzerEinsatzortConstants.BEMERKUNG_MAX_LENGTH)
        
  protected java.lang.String bemerkung =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBemerkung = false;

  public boolean hasChangedBemerkung(){
    return hasChangedBemerkung;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBemerkung = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBemerkung;
  
  /**
   * 
   *
   * getter for BENUTZER_EINSATZORT.BEMERKUNG
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBemerkung() {
        return bemerkung;
      }

  /**
   * 
   *
   * setter for BENUTZER_EINSATZORT.BEMERKUNG
   *
   * @param bemerkung
   */
  @Override   public void setBemerkung(@javax.annotation.Nullable  java.lang.String bemerkung) {

       resetTkCache();
                  
                          java.lang.String bemerkungInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(bemerkung, BenutzerEinsatzortConstants.BEMERKUNG_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.bemerkung
      , bemerkungInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBemerkung |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("bemerkung");
      }


             if (!isSeitLadenVeraendertBemerkung) {
          isSeitLadenVeraendertBemerkung = thisAttributChanged;
         if (isSeitLadenVeraendertBemerkung){
           wertNachLadenBemerkung=this.bemerkung;
         }
       }
      

       this.bemerkung = bemerkungInternal;

         }

        
  @javax.persistence.Column(name = "BESONDERHEIT", nullable = BenutzerEinsatzortConstants.BESONDERHEIT_NULLABLE, length=BenutzerEinsatzortConstants.BESONDERHEIT_MAX_LENGTH)
        
  protected java.lang.String besonderheit =  null;

  @javax.persistence.Transient
  protected boolean hasChangedBesonderheit = false;

  public boolean hasChangedBesonderheit(){
    return hasChangedBesonderheit;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertBesonderheit = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenBesonderheit;
  
  /**
   * 
   *
   * getter for BENUTZER_EINSATZORT.BESONDERHEIT
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getBesonderheit() {
        return besonderheit;
      }

  /**
   * 
   *
   * setter for BENUTZER_EINSATZORT.BESONDERHEIT
   *
   * @param besonderheit
   */
  @Override   public void setBesonderheit(@javax.annotation.Nullable  java.lang.String besonderheit) {

       resetTkCache();
                  
                          java.lang.String besonderheitInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(besonderheit, BenutzerEinsatzortConstants.BESONDERHEIT_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.besonderheit
      , besonderheitInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedBesonderheit |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("besonderheit");
      }


             if (!isSeitLadenVeraendertBesonderheit) {
          isSeitLadenVeraendertBesonderheit = thisAttributChanged;
         if (isSeitLadenVeraendertBesonderheit){
           wertNachLadenBesonderheit=this.besonderheit;
         }
       }
      

       this.besonderheit = besonderheitInternal;

         }

        
  @javax.persistence.Column(name = "CLIENT_IP_MUSTER", nullable = BenutzerEinsatzortConstants.CLIENT_IP_MUSTER_NULLABLE, length=BenutzerEinsatzortConstants.CLIENT_IP_MUSTER_MAX_LENGTH)
        
  protected java.lang.String clientIpMuster =  null;

  @javax.persistence.Transient
  protected boolean hasChangedClientIpMuster = false;

  public boolean hasChangedClientIpMuster(){
    return hasChangedClientIpMuster;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertClientIpMuster = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenClientIpMuster;
  
  /**
   * 
   *
   * getter for BENUTZER_EINSATZORT.CLIENT_IP_MUSTER
   */
  @javax.annotation.Nullable   @Override   public  java.lang.String getClientIpMuster() {
        return clientIpMuster;
      }

  /**
   * 
   *
   * setter for BENUTZER_EINSATZORT.CLIENT_IP_MUSTER
   *
   * @param clientIpMuster
   */
  @Override   public void setClientIpMuster(@javax.annotation.Nullable  java.lang.String clientIpMuster) {

       resetTkCache();
                  
                          java.lang.String clientIpMusterInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(clientIpMuster, BenutzerEinsatzortConstants.CLIENT_IP_MUSTER_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.clientIpMuster
      , clientIpMusterInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedClientIpMuster |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("clientIpMuster");
      }


             if (!isSeitLadenVeraendertClientIpMuster) {
          isSeitLadenVeraendertClientIpMuster = thisAttributChanged;
         if (isSeitLadenVeraendertClientIpMuster){
           wertNachLadenClientIpMuster=this.clientIpMuster;
         }
       }
      

       this.clientIpMuster = clientIpMusterInternal;

         }

        
      @javax.persistence.Column(name = "NAME", nullable = BenutzerEinsatzortConstants.NAME_NULLABLE, length=BenutzerEinsatzortConstants.NAME_MAX_LENGTH)
        
  protected java.lang.String name =  null;

  @javax.persistence.Transient
  protected boolean hasChangedName = false;

  public boolean hasChangedName(){
    return hasChangedName;
  }
       @javax.persistence.Transient
     private transient boolean isSeitLadenVeraendertName = false;
     @javax.persistence.Transient
     private transient java.lang.String wertNachLadenName;
  
  /**
   * 
   *
   * getter for BENUTZER_EINSATZORT.NAME
   */
    @Override   public  java.lang.String getName() {
        return name;
      }

  /**
   * 
   *
   * setter for BENUTZER_EINSATZORT.NAME
   *
   * @param name
   */
  @Override   public void setName( java.lang.String name) {

       resetTkCache();
                  
                          java.lang.String nameInternal = de.ivu.elect.jee.entity.EntityUtil.trimToNullOrMaxLength(name, BenutzerEinsatzortConstants.NAME_MAX_LENGTH, getId(), getClass());
                  
       
      boolean thisAttributChanged =
      !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.name
      , nameInternal);

      attributeChanged |= thisAttributChanged;

      hasChangedName |= thisAttributChanged;

      if (thisAttributChanged) {
      markDirty("name");
      }


             if (!isSeitLadenVeraendertName) {
          isSeitLadenVeraendertName = thisAttributChanged;
         if (isSeitLadenVeraendertName){
           wertNachLadenName=this.name;
         }
       }
      

       this.name = nameInternal;

         }

    
/**
 * Beziehungen N:1 unidirektional
 */
  /**
   * Beziehung (unidirektional) zu Mandant
   */
  @javax.persistence.ManyToOne(fetch =  javax.persistence.FetchType.LAZY , optional=false, cascade = {javax.persistence.CascadeType.PERSIST})
  @javax.persistence.JoinColumns(@javax.persistence.JoinColumn(name = "MANDANT_ID", referencedColumnName="MANDANT_ID"))
  protected de.ivu.elect.business.mandant.entity.Mandant mandant;

  /**
   * 
   */
  @Override
  public void setMandant( de.ivu.elect.business.mandant.entity.Mandant mandant){
    resetTkCache();
    
    boolean thisAttributChanged =
    !de.ivu.elect.jee.entity.EntityUtil.compareObjects(this.mandant
    , mandant);

    attributeChanged |= thisAttributChanged;

    hasChangedMandant |= thisAttributChanged;

    if (thisAttributChanged) {
    markDirty("mandant");
    }

    this.mandant = mandant;
      }

  /**
   * 
   */
    @Override
  public de.ivu.elect.business.mandant.entity.Mandant getMandant(){
    return this.mandant;
  }

  @javax.persistence.Transient
  protected boolean hasChangedMandant = false;

  public boolean hasChangedMandant(){
    return hasChangedMandant;
  }


/**
 * Beziehungen N:1 bidirektional
 */

  /**
   * Beziehungen 1:N unidirektional (nicht unterstuetzt)
   */

  /**
   * Beziehungen 1:N bidirektional
   */

  /**
   * Beziehungen N:M bidirektional nicht selbstreferenzierend
   */
  /**
   * Beziehung N:M (bidirektional, fuehrend) zu Rolles
   */
  @javax.persistence.ManyToMany(fetch=javax.persistence.FetchType.LAZY)
  @javax.persistence.JoinTable(name="BENUTZER_EINSATZORT_ROLLE",
     joinColumns = {@javax.persistence.JoinColumn(name="BENUTZER_EINSATZORT_ID", referencedColumnName="benutzer_einsatzort_id")},
     inverseJoinColumns = {@javax.persistence.JoinColumn(name="ROLLE_ID", referencedColumnName="ROLLE_ID")}) 
// elect deaktiviert, gibt Probleme beim Löschen   @org.hibernate.annotations.Cache(usage = org.hibernate.annotations.CacheConcurrencyStrategy.TRANSACTIONAL)
  protected java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> rolles;

  /**
   * getter muss read-only verwendet werden, da die Beziehung auf der anderen Seite nicht aktualisiert wird!
   */
  @Override
  public java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> getRolles(){
    if (rolles == null){
      return  java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>unmodifiableSet(java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>emptySet());
    }
    return java.util.Collections.<de.ivu.elect.business.benutzerverwaltung.entity.Rolle>unmodifiableSet(this.rolles);
  }


  @javax.persistence.Transient
  private boolean hasChangedRolles = false;

  public boolean hasChangedRolles() {
    return hasChangedRolles;
  }


 /**
  * Hinzufuegen von de.ivu.elect.business.benutzerverwaltung.entity.Rolle
  */
  @Override
  public void addRolle(de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolle){
    try {
      if (!updateRelationship){
        updateRelationship = true;

        if (rolle != null){
          if (this.rolles == null){
            this.rolles = new java.util.HashSet<>();
          }

          boolean isChanged = this.rolles.add(rolle);

          if(!hasChangedRolles) {
            hasChangedRolles =  isChanged;
          }

              // andere Seite der Beziehung aktualisieren
          rolle.addBenutzerEinsatzort(this);
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

  /**
   * Entfernen von de.ivu.elect.business.benutzerverwaltung.entity.Rolle
   */
  @Override
  public void removeRolle(de.ivu.elect.business.benutzerverwaltung.entity.Rolle rolle){
    try {
      if (!updateRelationship){
        updateRelationship = true;
        if (rolle != null){
          if (this.rolles != null){
            boolean isChanged = this.rolles.remove(rolle);

            if(!hasChangedRolles) {
              hasChangedRolles =  isChanged;
            }
          }

                    // andere Seite der Beziehung aktualisieren
          if (rolle != null) {
            rolle.removeBenutzerEinsatzort(this);
          }
                  }
      }
    } finally {
      updateRelationship = false;
    }
  }

 /**
  * Entfernen von allen  de.ivu.elect.business.benutzerverwaltung.entity.Rolle
  */
   @Override
   public void removeAllRolles(){
     java.util.Set<de.ivu.elect.business.benutzerverwaltung.entity.Rolle> toRemove = new java.util.HashSet<>(getRolles());

     for (   de.ivu.elect.business.benutzerverwaltung.entity.Rolle entity:toRemove){
       removeRolle(entity);
     }
   }


  /**
   * Beziehungen N:M bidirektional selbstreferenzierend
   */
  

  @Override
  public String toString() {
    StringBuilder sb = new StringBuilder();
    sb.append("BenutzerEinsatzort:");
    sb.append(getId());
    sb.append(" (TK: ");
    try {
      sb.append(getTk());
    } catch (Exception e) {
      sb.append(e.getMessage());
    }
    sb.append(")");
    return sb.toString();
}



  /**
   * Kopiert alle Attribute (ausser PK und Version) und UNIDIREKTIONALE n:1-Beziehungen in uebergebene Entitaet.
   *
   * @param other
   *
   * @deprecated Sollte nur mit Bedacht genutzt werden, da hier auch die Beziehungen kopiert werden. Deswegen markiert
   *             als Deprecated.
   */
  @Deprecated
  protected void copyEntity(BenutzerEinsatzort other){
                             other.bemerkung = this.bemerkung;
                                other.besonderheit = this.besonderheit;
                                other.clientIpMuster = this.clientIpMuster;
                                other.name = this.name;
           
  other.setMandant(this.getMandant());


  }



    @Override
    public void copyEntityAttributesToOtherEntity(de.ivu.elect.jee.entity.Entity other) {
      if (other==null){
        return;
      }
      if (other.isInstanceOf(BenutzerEinsatzort.class)){
        copyEntityAttributesUsingSetter((BenutzerEinsatzort) other.castTo(BenutzerEinsatzort.class).getEntity());
      } else {
        throw new IllegalArgumentException("Keine Instanz von BenutzerEinsatzort: " + other);
      }
    }

  /**
  * Kopiert alle Attribute (ausser PK und Version)  in uebergebene Entitaet.
  *
  */
  public void copyEntityAttributesUsingSetter(BenutzerEinsatzort other){
               other.setBemerkung(this.bemerkung);
                  other.setBesonderheit(this.besonderheit);
                  other.setClientIpMuster(this.clientIpMuster);
                  other.setName(this.name);
       
  }


  /**
   * Kopiert alle veränderten Attribute (ausser PK, CustomData, wenn vorhanden und Version) in uebergebene Entitaet.
   *
   */
  public void copyChangedEntityAttributesUsingSetter(BenutzerEinsatzort other){
                       if (hasChangedBemerkung) {
        other.setBemerkung(this.bemerkung);
      }
                             if (hasChangedBesonderheit) {
        other.setBesonderheit(this.besonderheit);
      }
                             if (hasChangedClientIpMuster) {
        other.setClientIpMuster(this.clientIpMuster);
      }
                             if (hasChangedName) {
        other.setName(this.name);
      }
             }





    @javax.persistence.Transient
    private transient BenutzerEinsatzortTK tkCache;

    protected void resetTkCache() {
        tkCache = null;
    }

    public BenutzerEinsatzortTK getBenutzerEinsatzortTK(){
    if (tkCache==null) {
    tkCache = new BenutzerEinsatzortTK(

getName()


  );}
  return tkCache;
}
    @Override
    public de.ivu.elect.jee.entity.tk.EntityTK getTk() {
       return getBenutzerEinsatzortTK();
    }

  @Override
  public BenutzerEinsatzortUK getUk(){
    return getBenutzerEinsatzortUK();
  }

  @Override
  public Class< ? > getEntityClass() {
    return BenutzerEinsatzort.class;
  }

public BenutzerEinsatzortUK getBenutzerEinsatzortUK(){

   return  new BenutzerEinsatzortUK(

getName()
,     getMandant()==null?null:getMandant().getMandantUK()


  );
}

  @javax.persistence.Transient
  private transient BenutzerEinsatzortProperties properties;

  public BenutzerEinsatzortProperties getProperties(){
    if (properties == null) {
      properties = new BenutzerEinsatzortProperties(this);
    }
    return properties;
  }

  /**
   * @deprecated getProperties() verwenden.
   */
  @Deprecated
  public BenutzerEinsatzortProperties getBenutzerEinsatzortProperties(){
    return getProperties();
  }

  @Override
  public String getEntityTechnicalName() {
    return BenutzerEinsatzortConstants.MESSAGE_KEY_ENTITY_EINZAHL;
  }

  @Override
  public boolean isAenderungenProtokollieren(){
    
    return true;
  }


    @Override
   public void setProtokollierteAttributeMitWerten(java.util.Map<String, de.ivu.elect.jee.protokollierung.AttributWertVorher> werteVorher) {
     
      if (werteVorher.containsKey(BenutzerEinsatzortConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerEinsatzortConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL);

        bemerkung =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerEinsatzortConstants.MESSAGE_KEY_BESONDERHEIT_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerEinsatzortConstants.MESSAGE_KEY_BESONDERHEIT_EINZAHL);

        besonderheit =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerEinsatzortConstants.MESSAGE_KEY_CLIENT_IP_MUSTER_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerEinsatzortConstants.MESSAGE_KEY_CLIENT_IP_MUSTER_EINZAHL);

        clientIpMuster =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

            
      if (werteVorher.containsKey(BenutzerEinsatzortConstants.MESSAGE_KEY_NAME_EINZAHL)){
        de.ivu.elect.jee.protokollierung.AttributWertVorher vorher = werteVorher.get(BenutzerEinsatzortConstants.MESSAGE_KEY_NAME_EINZAHL);

        name =
     vorher.getAttributTyp().getValueAsString(vorher.getWertVorher());
          }

                }

  @Override
  public java.util.Map<String, de.ivu.elect.jee.protokollierung.VorherNachherWert> getProtokollierteAttributeMitWerten() {
    java.util.Map<String,de.ivu.elect.jee.protokollierung.VorherNachherWert> result;
        result = createEmptyProtokollierteAttributeMitWertenMap();
                        if (isSeitLadenVeraendertBemerkung) {
      result.put(BenutzerEinsatzortConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBemerkung , bemerkung));
    }
                            if (isSeitLadenVeraendertBesonderheit) {
      result.put(BenutzerEinsatzortConstants.MESSAGE_KEY_BESONDERHEIT_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenBesonderheit , besonderheit));
    }
                            if (isSeitLadenVeraendertClientIpMuster) {
      result.put(BenutzerEinsatzortConstants.MESSAGE_KEY_CLIENT_IP_MUSTER_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenClientIpMuster , clientIpMuster));
    }
                            if (isSeitLadenVeraendertName) {
      result.put(BenutzerEinsatzortConstants.MESSAGE_KEY_NAME_EINZAHL, new de.ivu.elect.jee.protokollierung.VorherNachherWert(
         de.ivu.elect.jee.protokollierung.AttributTyp.STRING
                , wertNachLadenName , name));
    }
                return result;
  }

  @Override
  public void resetProtokollierteAttribute() {
                      isSeitLadenVeraendertBemerkung = false;
      wertNachLadenBemerkung = null;
                          isSeitLadenVeraendertBesonderheit = false;
      wertNachLadenBesonderheit = null;
                          isSeitLadenVeraendertClientIpMuster = false;
      wertNachLadenClientIpMuster = null;
                          isSeitLadenVeraendertName = false;
      wertNachLadenName = null;
                   }

  @Override
  public  java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> getFachlichAbhaengigeEntitaeten(){
            java.util.List<de.ivu.elect.jee.entity.EntityFachlichAbhaengigNode> result = new java.util.ArrayList<>();
                    return result;
  }

        
            protected String getInitialDiscriminator() {
              return "BENUTZER_EINSATZORT";
            }

            @Override
            public boolean isInstanceOf(Class<?> clazz) {
            return clazz.isInstance(this);
            }


            @Override
            public <E> de.ivu.elect.jee.entity.EntityContainer<E> castTo(Class<E> clazz) {
                return new de.ivu.elect.jee.entity.EntityContainer<>((E)this); // EntityContainer ist notwendig, da sonst von Hibernate die Entität wieder durch ihren Proxy ersetzt wird...
            }

  public boolean isPersistent() {
    return getId() != null;
  }


   private static final String BASE_CLASS_NAME = "BenutzerEinsatzort";
   @Override
   public String getBaseClassName() {
     return BASE_CLASS_NAME;
   }


    @Override
    public boolean equals(Object obj) {
    if (obj == null) {
    return false;
    }

    if (this==obj) {
    return true;
    }


    if (id != null) {
      try {
        return id.longValue() == ((de.ivu.elect.jee.entity.Entity) obj).getId().longValue() && BASE_CLASS_NAME.equals(((de.ivu.elect.jee.entity.Entity) obj).getBaseClassName());
      } catch (Exception ignored) {
        // do nothing
        return false;
      }
    }
   return super.equals(obj);
    }

    @Override
    public int hashCode() {

      if (id==null){
        return super.hashCode();
      }
      return id.hashCode();
    }


                            @javax.persistence.Transient
                private transient java.util.Set
            <String> dirtyProperties = null;

                protected void markDirty(String property) {
            
          }

          public java.util.Set
      <String> getDirtyProperties() {
          if (dirtyProperties==null){
          dirtyProperties = new java.util.HashSet<>();
          }
          return dirtyProperties;
          }

          public void clearDirtyProperties(){
          dirtyProperties = null;
          }
          public boolean isHibernateDirty() {
            return dirtyProperties!=null;
          }

      
                public void resetValidation() {
        
    validationResult = null;
        }

        @javax.persistence.Transient
        private transient java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validationResult;

                    public java.util.Set<de.ivu.elect.jee.entity.EntityConstraintViolation> validateEntity() {
            if (validationResult==null) {
               validationResult  = new java.util.HashSet<>();
                                                                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerEinsatzortConstants.BEMERKUNG_MAX_LENGTH ,  bemerkung, this, BenutzerEinsatzortConstants.MESSAGE_KEY_BEMERKUNG_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerEinsatzortConstants.BESONDERHEIT_MAX_LENGTH ,  besonderheit, this, BenutzerEinsatzortConstants.MESSAGE_KEY_BESONDERHEIT_EINZAHL, validationResult);
                                                                                                   de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerEinsatzortConstants.CLIENT_IP_MUSTER_MAX_LENGTH ,  clientIpMuster, this, BenutzerEinsatzortConstants.MESSAGE_KEY_CLIENT_IP_MUSTER_EINZAHL, validationResult);
                                                           de.ivu.elect.jee.entity.EntityConstraintCheck.checkNotNull(name, this, BenutzerEinsatzortConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                                                          de.ivu.elect.jee.entity.EntityConstraintCheck.checkStringLength(BenutzerEinsatzortConstants.NAME_MAX_LENGTH , 1 ,  name, this, BenutzerEinsatzortConstants.MESSAGE_KEY_NAME_EINZAHL, validationResult);
                                    }
             return validationResult;
        }

            
        @javax.persistence.Transient
        private transient java.util.Map<String, Object> transientContext;

        public java.util.Map<String, Object> getTransientContext() {
          if (transientContext == null) {
             transientContext = new java.util.HashMap<>();
          }
        return transientContext;

        }

              }
